diff a/test/micro/org/openjdk/bench/valhalla/acmp/field/InlineIsCmpBranch64long.java b/test/micro/org/openjdk/bench/valhalla/acmp/field/InlineIsCmpBranch64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/field/InlineIsCmpBranch64long.java
@@ -0,0 +1,245 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.field;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+/*
+ *  For proper results it should be executed:
+ *  java -jar target/benchmarks.jar baseline.acmp.IsCmpBranch  -wmb baseline.acmp.IsCmpBranch.equals050
+ */
+
+@Fork(3)
+@Warmup(iterations = 3, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class InlineIsCmpBranch64long extends StatesQ64long {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Obj(ObjWrapper[] objects1, ObjWrapper[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i].f == objects2[i].f) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Int(IntWrapper[] objects1, IntWrapper[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i].f == objects2[i].f) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Ref(RefWrapper[] objects1, RefWrapper[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i].f == objects2[i].f) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Val(ValWrapper[] objects1, ValWrapper[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i].f == objects2[i].f) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals000(ObjState00 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals025(ObjState25 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals050(ObjState50 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals075(ObjState75 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals100(ObjState100 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals000(IntState00 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals025(IntState25 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals050(IntState50 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals075(IntState75 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals100(IntState100 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals000(RefState00 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals025(RefState25 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals050(RefState50 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals075(RefState75 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals100(RefState100 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals000(ValState00 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals025(ValState25 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals050(ValState50 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals075(ValState75 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals100(ValState100 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/acmp/field/StatesQ64long.java b/test/micro/org/openjdk/bench/valhalla/acmp/field/StatesQ64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/field/StatesQ64long.java
@@ -0,0 +1,332 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.field;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+
+import java.util.BitSet;
+import java.util.Random;
+
+public class StatesQ64long {
+
+    public static final int SIZE = 100;
+
+    private static BitSet indices(Random rnd, int bound, int size) {
+        return rnd.ints(0, bound)
+                .distinct()
+                .limit(size)
+                .collect(BitSet::new, BitSet::set, BitSet::or);
+    }
+
+    private static void populate(ObjWrapper[] arr1, ObjWrapper[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                arr2[i] = arr1[i] = new ObjWrapper(new Q64long(i));
+            } else {
+                arr1[i] = new ObjWrapper(new Q64long(2 * i));
+                arr2[i] = new ObjWrapper(new Q64long(2 * i + 1));
+            }
+        }
+    }
+
+    private static void populate(IntWrapper[] arr1, IntWrapper[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                arr2[i] = arr1[i] = new IntWrapper(new Q64long(i));
+            } else {
+                arr1[i] = new IntWrapper(new Q64long(2 * i));
+                arr2[i] = new IntWrapper(new Q64long(2 * i + 1));
+            }
+        }
+    }
+
+    private static void populate(RefWrapper[] arr1, RefWrapper[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                arr2[i] = arr1[i] = new RefWrapper(new Q64long(i));
+            } else {
+                arr1[i] = new RefWrapper(new Q64long(2 * i));
+                arr2[i] = new RefWrapper(new Q64long(2 * i + 1));
+            }
+        }
+    }
+
+    private static void populate(ValWrapper[] arr1, ValWrapper[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                arr2[i] = arr1[i] = new ValWrapper(new Q64long(i));
+            } else {
+                arr1[i] = new ValWrapper(new Q64long(2 * i));
+                arr2[i] = new ValWrapper(new Q64long(2 * i + 1));
+            }
+        }
+    }
+
+    public static class ObjWrapper {
+        public Object f;
+
+        public ObjWrapper(Object f) {
+            this.f = f;
+        }
+    }
+
+
+    @State(Scope.Thread)
+    public abstract static class ObjState {
+        ObjWrapper[] arr1, arr2;
+    }
+
+    public static class IntWrapper {
+        public Int64 f;
+
+        public IntWrapper(Int64 f) {
+            this.f = f;
+        }
+    }
+
+    @State(Scope.Thread)
+    public abstract static class IntState {
+        IntWrapper[] arr1, arr2;
+    }
+
+    public static class RefWrapper {
+        public Q64long f;
+
+        public RefWrapper(Q64long f) {
+            this.f = f;
+        }
+    }
+
+
+    @State(Scope.Thread)
+    public abstract static class RefState {
+        RefWrapper[] arr1, arr2;
+    }
+
+    public static class ValWrapper {
+        public Q64long f;
+
+        public ValWrapper(Q64long f) {
+            this.f = f;
+        }
+    }
+
+
+    @State(Scope.Thread)
+    public abstract static class ValState {
+        ValWrapper[] arr1, arr2;
+    }
+
+    public static class ObjState00 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new ObjWrapper[SIZE];
+            arr2 = new ObjWrapper[SIZE];
+            populate(arr1, arr2, 0);
+        }
+
+    }
+
+    public static class ObjState25 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new ObjWrapper[SIZE];
+            arr2 = new ObjWrapper[SIZE];
+            populate(arr1, arr2, 25);
+        }
+
+    }
+
+    public static class ObjState50 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new ObjWrapper[SIZE];
+            arr2 = new ObjWrapper[SIZE];
+            populate(arr1, arr2, 50);
+        }
+
+    }
+
+    public static class ObjState75 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new ObjWrapper[SIZE];
+            arr2 = new ObjWrapper[SIZE];
+            populate(arr1, arr2, 75);
+        }
+
+    }
+
+    public static class ObjState100 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new ObjWrapper[SIZE];
+            arr2 = new ObjWrapper[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class IntState00 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new IntWrapper[SIZE];
+            arr2 = new IntWrapper[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class IntState25 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new IntWrapper[SIZE];
+            arr2 = new IntWrapper[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class IntState50 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new IntWrapper[SIZE];
+            arr2 = new IntWrapper[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class IntState75 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new IntWrapper[SIZE];
+            arr2 = new IntWrapper[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class IntState100 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new IntWrapper[SIZE];
+            arr2 = new IntWrapper[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class RefState00 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new RefWrapper[SIZE];
+            arr2 = new RefWrapper[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class RefState25 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new RefWrapper[SIZE];
+            arr2 = new RefWrapper[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class RefState50 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new RefWrapper[SIZE];
+            arr2 = new RefWrapper[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class RefState75 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new RefWrapper[SIZE];
+            arr2 = new RefWrapper[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class RefState100 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new RefWrapper[SIZE];
+            arr2 = new RefWrapper[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class ValState00 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new ValWrapper[SIZE];
+            arr2 = new ValWrapper[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class ValState25 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new ValWrapper[SIZE];
+            arr2 = new ValWrapper[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class ValState50 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new ValWrapper[SIZE];
+            arr2 = new ValWrapper[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class ValState75 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new ValWrapper[SIZE];
+            arr2 = new ValWrapper[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class ValState100 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new ValWrapper[SIZE];
+            arr2 = new ValWrapper[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/acmp/trivial/IdentityTrivialEquals.java b/test/micro/org/openjdk/bench/valhalla/acmp/trivial/IdentityTrivialEquals.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/trivial/IdentityTrivialEquals.java
@@ -0,0 +1,84 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.trivial;
+
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+/*
+ * to provide proper measurement the benchmark have to be executed in two modes:
+ *  -wm INDI
+ *  -wm BULK
+ */
+@Fork(1)
+@Warmup(iterations = 3, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class IdentityTrivialEquals {
+
+    Object o1 = new R64long(1);
+    Object o2 = new R64long(2);
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static boolean cmpEquals(Object a, Object b) {
+        return a == b;     }
+
+    @Benchmark
+    public boolean isCmp_null_null() {
+        return cmpEquals(null, null);
+    }
+
+    @Benchmark
+    public boolean isCmp_o1_null() {
+        return cmpEquals(o1, null);
+    }
+
+    @Benchmark
+    public boolean isCmp_null_o1() {
+        return cmpEquals(null, o1);
+    }
+
+    @Benchmark
+    public boolean isCmp_o1_o1() {
+        return cmpEquals(o1, o1);
+    }
+
+    @Benchmark
+    public boolean isCmp_o1_o2() {
+        return cmpEquals(o1, o2);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/acmp/trivial/IdentityTrivialNotEquals.java b/test/micro/org/openjdk/bench/valhalla/acmp/trivial/IdentityTrivialNotEquals.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/trivial/IdentityTrivialNotEquals.java
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.trivial;
+
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+/*
+ * to provide proper measurement the benchmark have to be executed in two modes:
+ *  -wm INDI
+ *  -wm BULK
+ */
+
+@Fork(1)
+@Warmup(iterations = 3, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class IdentityTrivialNotEquals {
+
+    Object o1 = new R64long(1);
+    Object o2 = new R64long(2);
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static boolean cmpNotEquals(Object a, Object b) {
+        return a != b; // new acmp
+    }
+
+    @Benchmark
+    public boolean isNotCmp_null_null() {
+        return cmpNotEquals(null, null);
+    }
+
+    @Benchmark
+    public boolean isNotCmp_o1_null() {
+        return cmpNotEquals(o1, null);
+    }
+
+    @Benchmark
+    public boolean isNotCmp_null_o1() {
+        return cmpNotEquals(null, o1);
+    }
+
+    @Benchmark
+    public boolean isNotCmp_o1_o1() {
+        return cmpNotEquals(o1, o1);
+    }
+
+    @Benchmark
+    public boolean isNotCmp_o1_o2() {
+        return cmpNotEquals(o1, o2);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/copy/Identity32int.java b/test/micro/org/openjdk/bench/valhalla/array/copy/Identity32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/copy/Identity32int.java
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.copy;
+
+import org.openjdk.bench.valhalla.array.util.StatesR32int;
+import org.openjdk.bench.valhalla.types.R32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Identity32int extends StatesR32int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_copy(Ref_as_Ref s, Ref_as_Ref d) {
+        R32int[] src = s.arr;
+        R32int[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i] = src[i];
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_arraycopy(Ref_as_Ref s, Ref_as_Ref d) {
+        System.arraycopy(s.arr, 0, d.arr, 0, s.arr.length);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/array/copy/Inline128int.java b/test/micro/org/openjdk/bench/valhalla/array/copy/Inline128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/array/copy/Inline128int.java
@@ -0,0 +1,80 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.array.copy;
+
+import org.openjdk.bench.valhalla.array.util.StatesQ128int;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline128int extends StatesQ128int {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_copy(Val_as_Val s, Val_as_Val d) {
+        Q128int[] src = s.arr;
+        Q128int[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i] = src[i];
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_arraycopy(Val_as_Val s, Val_as_Val d) {
+        System.arraycopy(s.arr, 0, d.arr, 0, s.arr.length);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_copy(Ref_as_Ref s, Val_as_Val d) {
+        Q128int[] src = s.arr;
+        Q128int[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i] = src[i];
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_arraycopy(Ref_as_Ref s, Val_as_Val d) {
+        System.arraycopy(s.arr, 0, d.arr, 0, s.arr.length);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_copy(Val_as_Val s, Ref_as_Ref d) {
+        Q128int[] src = s.arr;
+        Q128int[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i] = src[i];
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_arraycopy(Val_as_Val s, Ref_as_Ref d) {
+        System.arraycopy(s.arr, 0, d.arr, 0, s.arr.length);
+    }
+
+}
